/* LICENSE BLOCK
Part of mde: a Modular D game-oriented Engine
Copyright © 2007-2008 Diggory Hardy

This program is free software: you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation, either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/** This module is for interfacing with the mde.mde module (or other module containing main()) and
 * some global items. */
module mde.imde;

import mde.input.Input;
import mde.scheduler.Scheduler;

static this () {
    // Make these available to all importing modules' static CTORs, as well as during init.
    input = new Input();
    mainSchedule = new Scheduler;
}


Scheduler mainSchedule; /// The schedule used by the main loop.

/** Some enums used by per request scheduled functions. */
enum SCHEDULE : Scheduler.ID {
    DRAW
};

bool run = true;	// main loop continues if this is true

Input input;		// Input instance. When multiple users are allowed instances will be per-user.
